Index: src/boundary.cpp
===================================================================
--- src/boundary.cpp	(revision fee69b843bd5d32a84f98c5e371186c1bb704c1c)
+++ src/boundary.cpp	(revision 2414857c3831ba1486a06bbb005a62df4f3e9c11)
@@ -795,5 +795,5 @@
  * \return *mol pointer to new molecule with filled atoms
  */
-molecule * FillBoxWithMolecule(MoleculeListClass *List, molecule *filler, config &configuration, const double distance[NDIM], const double epsilon, const double RandomAtomDisplacement, const double RandomMolDisplacement, const bool DoRandomRotation)
+molecule * FillBoxWithMolecule(MoleculeListClass *List, molecule *filler, config &configuration, const double distance[NDIM], const double RandomAtomDisplacement, const double RandomMolDisplacement, const bool DoRandomRotation)
 {
 	Info FunctionInfo(__func__);
@@ -856,5 +856,5 @@
             FillIt = false;
           } else {
-            const bool FillResult = (!TesselStruct[i]->IsInnerPoint(CurrentPosition, LCList[i], epsilon));
+            const bool FillResult = (!TesselStruct[i]->IsInnerPoint(CurrentPosition, LCList[i]));
             FillIt = FillIt && FillResult;
             if (FillResult) {
Index: src/boundary.hpp
===================================================================
--- src/boundary.hpp	(revision fee69b843bd5d32a84f98c5e371186c1bb704c1c)
+++ src/boundary.hpp	(revision 2414857c3831ba1486a06bbb005a62df4f3e9c11)
@@ -49,5 +49,5 @@
 
 double ConvexizeNonconvexEnvelope(class Tesselation *&TesselStruct, const molecule * const mol, const char * const filename);
-molecule * FillBoxWithMolecule(MoleculeListClass *List, molecule *filler, config &configuration, const double distance[NDIM], const double epsilon, const double RandomAtomDisplacement, const double RandomMolDisplacement, const bool DoRandomRotation);
+molecule * FillBoxWithMolecule(MoleculeListClass *List, molecule *filler, config &configuration, const double distance[NDIM], const double RandomAtomDisplacement, const double RandomMolDisplacement, const bool DoRandomRotation);
 void FindConvexBorder(const molecule* const mol, Tesselation *&TesselStruct, const LinkedCell *LCList, const char *filename);
 Vector* FindEmbeddingHole(MoleculeListClass *mols, molecule *srcmol);
Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision fee69b843bd5d32a84f98c5e371186c1bb704c1c)
+++ src/builder.cpp	(revision 2414857c3831ba1486a06bbb005a62df4f3e9c11)
@@ -1417,6 +1417,6 @@
             Log() << Verbose(0) << "\t-e <file>\tSets the databases path to be parsed (default: ./)." << endl;
             Log() << Verbose(0) << "\t-E <id> <Z>\tChange atom <id>'s element to <Z>, <id> begins at 0." << endl;
-            Log() << Verbose(0) << "\t-f/F <dist> <order>\tFragments the molecule in BOSSANOVA manner (with/out rings compressed) and stores config files in same dir as config (return code 0 - fragmented, 2 - no fragmentation necessary)." << endl;
-            Log() << Verbose(0) << "\t-F\tFilling Box with water molecules." << endl;
+            Log() << Verbose(0) << "\t-f <dist> <order>\tFragments the molecule in BOSSANOVA manner (with/out rings compressed) and stores config files in same dir as config (return code 0 - fragmented, 2 - no fragmentation necessary)." << endl;
+            Log() << Verbose(0) << "\t-F <dist_x> <dist_y> <dist_z> <epsilon> <randatom> <randmol> <DoRotate>\tFilling Box with water molecules." << endl;
             Log() << Verbose(0) << "\t-g <file>\tParses a bond length table from the given file." << endl;
             Log() << Verbose(0) << "\t-h/-H/-?\tGive this help screen." << endl;
@@ -1738,5 +1738,5 @@
               if (argptr+6 >=argc) {
                 ExitFlag = 255;
-                eLog() << Verbose(0) << "Not enough or invalid arguments given for filling box with water: -F <dist_x> <dist_y> <dist_z> <epsilon> <randatom> <randmol> <DoRotate>" << endl;
+                eLog() << Verbose(0) << "Not enough or invalid arguments given for filling box with water: -F <dist_x> <dist_y> <dist_z> <randatom> <randmol> <DoRotate>" << endl;
                 performCriticalExit();
               } else {
@@ -1769,5 +1769,5 @@
                 for (int i=0;i<NDIM;i++)
                   distance[i] = atof(argv[argptr+i]);
-                Filling = FillBoxWithMolecule(molecules, filler, configuration, distance, atof(argv[argptr+3]), atof(argv[argptr+4]), atof(argv[argptr+5]), atoi(argv[argptr+6]));
+                Filling = FillBoxWithMolecule(molecules, filler, configuration, distance, atof(argv[argptr+3]), atof(argv[argptr+4]), atoi(argv[argptr+5]));
                 if (Filling != NULL) {
                   Filling->ActiveFlag = false;
Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision fee69b843bd5d32a84f98c5e371186c1bb704c1c)
+++ src/tesselation.cpp	(revision 2414857c3831ba1486a06bbb005a62df4f3e9c11)
@@ -3247,9 +3247,8 @@
  * @param point of which to check the position
  * @param *LC LinkedCell structure
- * @param epsilon Distance of \a &Point to Center of triangle (of point outwards) is tested less against this value (standard: -MYEPSILON)
  *
  * @return true if the point is inside the tesselation structure, false otherwise
  */
-bool Tesselation::IsInnerPoint(const Vector &Point, const LinkedCell* const LC, const double epsilon) const
+bool Tesselation::IsInnerPoint(const Vector &Point, const LinkedCell* const LC) const
 {
   Info FunctionInfo(__func__);
Index: src/tesselation.hpp
===================================================================
--- src/tesselation.hpp	(revision fee69b843bd5d32a84f98c5e371186c1bb704c1c)
+++ src/tesselation.hpp	(revision 2414857c3831ba1486a06bbb005a62df4f3e9c11)
@@ -312,5 +312,5 @@
     list<BoundaryTriangleSet*> * FindClosestTrianglesToPoint(const Vector *x, const LinkedCell* LC) const;
     class BoundaryTriangleSet * FindClosestTriangleToPoint(const Vector *x, const LinkedCell* LC) const;
-    bool IsInnerPoint(const Vector &Point, const LinkedCell* const LC, const double epsilon = -MYEPSILON) const;
+    bool IsInnerPoint(const Vector &Point, const LinkedCell* const LC) const;
     bool AddBoundaryPoint(TesselPoint * Walker, const int n);
     DistanceToPointMap * FindClosestBoundaryPointsToVector(const Vector *x, const LinkedCell* LC) const;