Index: src/Helpers/Makefile.am
===================================================================
--- src/Helpers/Makefile.am	(revision 5605793b50554c75171309f425f1848783edb5d0)
+++ 	(revision )
@@ -1,64 +1,0 @@
-# PLEASE adhere to the alphabetical ordering in this Makefile!
-# Also indentation by a single tab
-
-INCLUDES = -I$(top_srcdir)/src
-
-AM_LDFLAGS = ${CodePatterns_LIBS} -ldl
-AM_CPPFLAGS = ${BOOST_CPPFLAGS} ${CodePatterns_CFLAGS}
-
-HELPERSOURCE = \
-	defs.cpp \
-	helpers.cpp
-				  
-HELPERHEADER = \
-	defs.hpp \
-	helpers.hpp
-
-
-lib_LTLIBRARIES = libMolecuilderHelpers.la
-libMolecuilderHelpers_la_includedir = $(includedir)/MoleCuilder/Helpers/
-nobase_libMolecuilderHelpers_la_include_HEADERS = ${HELPERHEADER}
-
-## Define the source file list for the "libexample-@MOLECUILDER_API_VERSION@.la"
-## target.  Note that @MOLECUILDER_API_VERSION@ is not interpreted by Automake and
-## will therefore be treated as if it were literally part of the target name,
-## and the variable name derived from that.
-## The file extension .cc is recognized by Automake, and makes it produce
-## rules which invoke the C++ compiler to produce a libtool object file (.lo)
-## from each source file.  Note that it is not necessary to list header files
-## which are already listed elsewhere in a _HEADERS variable assignment.
-libMolecuilderHelpers_la_SOURCES = ${HELPERSOURCE}
-
-## Instruct libtool to include ABI version information in the generated shared
-## library file (.so).  The library ABI version is defined in configure.ac, so
-## that all version information is kept in one place.
-libMolecuilderHelpers_la_LDFLAGS = -version-info $(MOLECUILDER_SO_VERSION)
-
-## The generated configuration header is installed in its own subdirectory of
-## $(libdir).  The reason for this is that the configuration information put
-## into this header file describes the target platform the installed library
-## has been built for.  Thus the file must not be installed into a location
-## intended for architecture-independent files, as defined by the Filesystem
-## Hierarchy Standard (FHS).
-## The nodist_ prefix instructs Automake to not generate rules for including
-## the listed files in the distribution on 'make dist'.  Files that are listed
-## in _HEADERS variables are normally included in the distribution, but the
-## configuration header file is generated at configure time and should not be
-## shipped with the source tarball.
-#libMolecuilderHelpers_libincludedir = $(libdir)/MoleCuilder/include
-#nodist_libMolecuilderHelpers_libinclude_HEADERS = $(top_builddir)/libmolecuilder_config.h
-
-## Install the generated pkg-config file (.pc) into the expected location for
-## architecture-dependent package configuration information.  Occasionally,
-## pkg-config files are also used for architecture-independent data packages,
-## in which case the correct install location would be $(datadir)/pkgconfig.
-#pkgconfigdir = $(libdir)/pkgconfig
-#pkgconfig_DATA = $(top_builddir)/MoleCuilder.pc
-
-unity.cpp:
-	echo "" >  unity.cpp; \
-	list='$(GRAPHSOURCE)'; for file in $$list; do \
-	  echo "#include \"$(srcdir)/$$file\"" >> unity.cpp; \
-	done;
-	
-MOSTLYCLEANFILES = unity.cpp
Index: src/Helpers/defs.hpp
===================================================================
--- src/Helpers/defs.hpp	(revision 5605793b50554c75171309f425f1848783edb5d0)
+++ src/Helpers/defs.hpp	(revision 2558294f484d39a0281f98d18f6262ab77448e87)
@@ -33,6 +33,4 @@
 
 //enum BondOrderScheme { NoScheme, BottomUp, TopDown, ANOVA, Combined }; //!< Fragmentation scheme used in BOSS
-
-
 
 //enum CutCyclicBond { KeepBond,  SaturateBond }; //!< Saturation scheme either atom- or bondwise 
Index: src/Helpers/helpers.cpp
===================================================================
--- src/Helpers/helpers.cpp	(revision 5605793b50554c75171309f425f1848783edb5d0)
+++ 	(revision )
@@ -1,35 +1,0 @@
-/*
- * Project: MoleCuilder
- * Description: creates and alters molecular systems
- * Copyright (C)  2010 University of Bonn. All rights reserved.
- * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
- */
-
-/** \file helpers.cpp
- *
- * Implementation of some auxiliary functions for memory dis-/allocation and so on
- */
-
-// include config.h
-#ifdef HAVE_CONFIG_H
-#include <config.h>
-#endif
-
-#include "CodePatterns/MemDebug.hpp"
-
-#include "CodePatterns/Verbose.hpp"
-#include "CodePatterns/Log.hpp"
-#include "Helpers/helpers.hpp"
-
-#include <iostream>
-
-/********************************************** helpful functions *********************************/
-
-
-/**
- * Calls exit(255).
- */
-void performCriticalExit() {
-  exit(255);
-}
-
Index: src/Helpers/helpers.hpp
===================================================================
--- src/Helpers/helpers.hpp	(revision 5605793b50554c75171309f425f1848783edb5d0)
+++ src/Helpers/helpers.hpp	(revision 2558294f484d39a0281f98d18f6262ab77448e87)
@@ -16,17 +16,13 @@
 #endif
 
-#include <fstream>
-
-#include "Helpers/defs.hpp"
-#include "CodePatterns/Log.hpp"
-
-/********************************************** definitions *********************************/
-
-/********************************************** helpful functions *********************************/
-
-void performCriticalExit();
+#include <cstdlib>
 
 /********************************************** helpful template functions *********************************/
 
+
+inline void performCriticalExit()
+{
+  exit(255);
+}
 
 