Index: tests/regression/Options/Session/post/complextest.sh
===================================================================
--- tests/regression/Options/Session/post/complextest.sh	(revision 8934261d0822b09d987a7630d515d95cfe3418bf)
+++ tests/regression/Options/Session/post/complextest.sh	(revision 8934261d0822b09d987a7630d515d95cfe3418bf)
@@ -0,0 +1,2 @@
+../../molecuilder \
+--verbose 2 --set-output "mpqc" "tremolo" --set-random-number-distribution "uniform_int" --random-number-distribution-parameters "p=1;" --change-box "20,0,20,0,0,20" --add-atom 1 --domain-position "1,1,1" --select-atom-by-id 0 0 --destroy-adjacency --create-adjacency --update-molecules  --select-atoms-molecules --fill-regular-grid --mesh-size 3 3 3 --mesh-offset "0.5,0.5,0.5" --min-distance 1 --tesselation-radius 0 --random-atom-displacement 0 --random-molecule-displacement 0 --DoRotate 0 --version
Index: tests/regression/Options/Session/testsuite-options-store-session-cli.at
===================================================================
--- tests/regression/Options/Session/testsuite-options-store-session-cli.at	(revision 8934261d0822b09d987a7630d515d95cfe3418bf)
+++ tests/regression/Options/Session/testsuite-options-store-session-cli.at	(revision 8934261d0822b09d987a7630d515d95cfe3418bf)
@@ -0,0 +1,46 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2013 Frederik Heber
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+### store session
+
+AT_SETUP([Standard Options - store session as CLI])
+AT_KEYWORDS([options store-session])
+AT_TESTED([bash diff])
+
+# check that session is stored and can be executed when correctly prefixed
+file=test.sh
+AT_DATA([$file], [../../molecuilder \ 
+])
+AT_CHECK([../../molecuilder --verbose 2 --version --store-session $file], 0, [ignore], [ignore])
+AT_CHECK([diff $file ${abs_top_srcdir}/tests/regression/Options/Session/post/$file], 0, [ignore], [ignore]) 
+AT_CHECK([bash ./$file], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+AT_SETUP([Standard Options - store complex session as CLI])
+AT_KEYWORDS([options store-session])
+AT_TESTED([bash diff])
+
+# check that session is stored and can be executed when correctly prefixed
+file=complextest.sh
+AT_DATA([$file], [../../molecuilder \ 
+])
+AT_CHECK([../../molecuilder --verbose 2 --set-output "mpqc" "tremolo" --set-random-number-distribution "uniform_int" --random-number-distribution-parameters "p=1;" --change-box "20,0,20,0,0,20" --add-atom 1 --domain-position "1,1,1" --select-atom-by-id 0 0 -I --select-atoms-molecules --fill-regular-grid --DoRotate 0 --mesh-offset ".5,.5,.5" --mesh-size 3 3 3 --version --store-session $file], 0, [ignore], [ignore])
+AT_CHECK([diff $file ${abs_top_srcdir}/tests/regression/Options/Session/post/$file], 0, [ignore], [ignore]) 
+AT_CHECK([bash ./$file], 0, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/regression/Options/Session/testsuite-options-store-session-python.at
===================================================================
--- tests/regression/Options/Session/testsuite-options-store-session-python.at	(revision 8934261d0822b09d987a7630d515d95cfe3418bf)
+++ tests/regression/Options/Session/testsuite-options-store-session-python.at	(revision 8934261d0822b09d987a7630d515d95cfe3418bf)
@@ -0,0 +1,30 @@
+#
+#    MoleCuilder - creates and alters molecular systems
+#    Copyright (C) 2013 Frederik Heber
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU General Public License as published by
+#    the Free Software Foundation, either version 3 of the License, or
+#    (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU General Public License for more details.
+#
+#    You should have received a copy of the GNU General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+### store session
+
+AT_SETUP([Standard Options - store session as Python])
+AT_KEYWORDS([options store-session])
+AT_TESTED([python diff])
+
+# check that session is stored and can be executed when correctly prefixed
+file=test.py
+AT_CHECK([../../molecuilder --verbose 2 --version --store-session $file --session-type "python"], 0, [ignore], [ignore])
+AT_CHECK([diff $file ${abs_top_srcdir}/tests/regression/Options/Session/post/$file], 0, [ignore], [ignore]) 
+AT_CHECK([../../runpython ./$file], 0, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/regression/Options/Session/testsuite-options-store-session.at
===================================================================
--- tests/regression/Options/Session/testsuite-options-store-session.at	(revision 9e4655500721048fec335b47c379e3d3d14e80ae)
+++ 	(revision )
@@ -1,32 +1,0 @@
-#
-#    MoleCuilder - creates and alters molecular systems
-#    Copyright (C) 2008-2012 University of Bonn
-#
-#    This program is free software: you can redistribute it and/or modify
-#    it under the terms of the GNU General Public License as published by
-#    the Free Software Foundation, either version 3 of the License, or
-#    (at your option) any later version.
-#
-#    This program is distributed in the hope that it will be useful,
-#    but WITHOUT ANY WARRANTY; without even the implied warranty of
-#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#    GNU General Public License for more details.
-#
-#    You should have received a copy of the GNU General Public License
-#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
-#
-### store session
-
-AT_SETUP([Standard Options - store session])
-AT_KEYWORDS([options store-session])
-#AT_TESTED([bash diff])
-
-# check that session is stored and can be executed when correctly prefixed
-file=test.sh
-AT_DATA([$file], [../../molecuilder \ 
-])
-AT_CHECK([../../molecuilder --verbose 2 --version --store-session $file], 0, [ignore], [ignore])
-AT_CHECK([diff $file ${abs_top_srcdir}/tests/regression/Options/Session/post/$file], 0, [ignore], [ignore]) 
-AT_CHECK([bash ./$file], 0, [ignore], [ignore])
-
-AT_CLEANUP
Index: tests/regression/Options/testsuite-options.at
===================================================================
--- tests/regression/Options/testsuite-options.at	(revision 9e4655500721048fec335b47c379e3d3d14e80ae)
+++ tests/regression/Options/testsuite-options.at	(revision 8934261d0822b09d987a7630d515d95cfe3418bf)
@@ -50,3 +50,4 @@
 
 # test store sessions
-m4_include([Options/Session/testsuite-options-store-session.at])
+m4_include([Options/Session/testsuite-options-store-session-cli.at])
+m4_include([Options/Session/testsuite-options-store-session-python.at])