Index: src/Actions/PotentialAction/FitPartialChargesAction.cpp
===================================================================
--- src/Actions/PotentialAction/FitPartialChargesAction.cpp	(revision fde8e77718575586ac9f71498a3f445dcb905bb4)
+++ src/Actions/PotentialAction/FitPartialChargesAction.cpp	(revision 208263749128e6e2d6a33f16e925eb8d6076e7a6)
@@ -56,4 +56,5 @@
 
 #include "Element/element.hpp"
+#include "Element/periodentafel.hpp"
 #include "Fragmentation/Homology/HomologyContainer.hpp"
 #include "Fragmentation/Homology/HomologyGraph.hpp"
Index: src/Actions/PotentialAction/ParseParticleParametersAction.cpp
===================================================================
--- src/Actions/PotentialAction/ParseParticleParametersAction.cpp	(revision 208263749128e6e2d6a33f16e925eb8d6076e7a6)
+++ src/Actions/PotentialAction/ParseParticleParametersAction.cpp	(revision 208263749128e6e2d6a33f16e925eb8d6076e7a6)
@@ -0,0 +1,120 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2016 Frederik Heber. All rights reserved.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * ParseParticleParametersAction.cpp
+ *
+ *  Created on: Feb 27, 2016
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+// include headers that implement a archive in simple text format
+// and before MemDebug due to placement new
+#include <boost/archive/text_oarchive.hpp>
+#include <boost/archive/text_iarchive.hpp>
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "Actions/PotentialAction/ParseParticleParametersAction.hpp"
+
+#include <boost/filesystem.hpp>
+#include <fstream>
+
+#include "CodePatterns/Log.hpp"
+
+#include "Potentials/Exceptions.hpp"
+#include "Potentials/Particles/ParticleFactory.hpp"
+#include "Potentials/Particles/ParticleRegistry.hpp"
+#include "Potentials/RegistryDeserializer.hpp"
+
+using namespace MoleCuilder;
+
+// and construct the stuff
+#include "ParseParticleParametersAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+
+ActionState::ptr PotentialParseParticleParametersAction::performCall()
+{
+  if (boost::filesystem::exists(params.particle_file.get())) {
+    std::ifstream returnstream(params.particle_file.get().string().c_str());
+    if (returnstream.good()) {
+      try {
+        RegistryDeserializer<Particle> deserialize(
+            returnstream,
+            ParticleFactory::getInstance(),
+            ParticleRegistry::getInstance(),
+            std::string("particle"));
+        deserialize();
+      } catch (SerializerMissingValueException &e) {
+        if (const std::string *key = boost::get_error_info<SerializerKey>(e))
+          STATUS("Missing value when parsing information for particle "+*key+".");
+        else
+          STATUS("Missing value parsing information for particle with unknown key.");
+        return Action::failure;
+      } catch (SerializerIllegalKeyException &e) {
+        if (const std::string *key = boost::get_error_info<SerializerKey>(e))
+          STATUS("Illegal key parsing information for particle "+*key+".");
+        else
+          STATUS("Illegal key parsing information for particle with unknown key.");
+        return Action::failure;
+      }
+    } else {
+      STATUS("Failed to parse from "+params.particle_file.get().string()+".");
+      return Action::failure;
+    }
+    returnstream.close();
+
+    LOG(0, "STATUS: Parsed a set of particle parameters parsed from "
+        << params.particle_file.get().string() << ".");
+
+  } else {
+      STATUS("No existing particles file given!");
+      return Action::failure;
+  }
+
+  return Action::success;
+}
+
+ActionState::ptr PotentialParseParticleParametersAction::performUndo(ActionState::ptr _state) {
+  STATUS("Undo of PotentialParseParticleParametersAction not implemented.");
+  return Action::failure;
+}
+
+ActionState::ptr PotentialParseParticleParametersAction::performRedo(ActionState::ptr _state){
+  STATUS("Redo of PotentialParseParticleParametersAction not implemented.");
+  return Action::failure;
+}
+
+bool PotentialParseParticleParametersAction::canUndo() {
+  return false;
+}
+
+bool PotentialParseParticleParametersAction::shouldUndo() {
+  return false;
+}
+/** =========== end of function ====================== */
Index: src/Actions/PotentialAction/ParseParticleParametersAction.def
===================================================================
--- src/Actions/PotentialAction/ParseParticleParametersAction.def	(revision 208263749128e6e2d6a33f16e925eb8d6076e7a6)
+++ src/Actions/PotentialAction/ParseParticleParametersAction.def	(revision 208263749128e6e2d6a33f16e925eb8d6076e7a6)
@@ -0,0 +1,38 @@
+/*
+ * ParseParticleParametersAction.def
+ *
+ *  Created on: Feb 27, 2016
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include "Parameters/Validators/Ops_Validator.hpp"
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+#include "Parameters/Validators/Specific/FileSuffixValidator.hpp"
+#include "Parameters/Validators/Ops_Validator.hpp"
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (boost::filesystem::path)
+#define paramtokens ("parse-particle-parameters")
+#define paramdescriptions ("TREMOLO particles file to parse")
+#define paramdefaults (NOPARAM_DEFAULT)
+#define paramreferences (particle_file)
+#define paramvalids \
+(FilePresentValidator() && (FileSuffixValidator("particles") || FileSuffixValidator("potentials")))
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Potential
+#define MENUNAME "potential"
+#define MENUPOSITION 1
+#define ACTIONNAME ParseParticleParameters
+#define TOKEN "parse-particle-parameters"
+
+
+// finally the information stored in the ActionTrait specialization
+#define DESCRIPTION "parses TREMOLO particle file into particle registry"
+#undef SHORTFORM
Index: src/Actions/PotentialAction/ParseParticleParametersAction.hpp
===================================================================
--- src/Actions/PotentialAction/ParseParticleParametersAction.hpp	(revision 208263749128e6e2d6a33f16e925eb8d6076e7a6)
+++ src/Actions/PotentialAction/ParseParticleParametersAction.hpp	(revision 208263749128e6e2d6a33f16e925eb8d6076e7a6)
@@ -0,0 +1,22 @@
+/*
+ * ParseParticleParametersAction.hpp
+ *
+ *  Created on: Feb 27, 2016
+ *      Author: heber
+ */
+
+#ifndef PARSEPARTICLEPARAMETERSACTION_HPP_
+#define PARSEPARTICLEPARAMETERSACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include "Actions/Action.hpp"
+
+#include "ParseParticleParametersAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* PARSEPARTICLEPARAMETERSACTION_HPP_ */
Index: src/Actions/PotentialAction/SaveParticleParametersAction.cpp
===================================================================
--- src/Actions/PotentialAction/SaveParticleParametersAction.cpp	(revision 208263749128e6e2d6a33f16e925eb8d6076e7a6)
+++ src/Actions/PotentialAction/SaveParticleParametersAction.cpp	(revision 208263749128e6e2d6a33f16e925eb8d6076e7a6)
@@ -0,0 +1,108 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2016 Frederik Heber. All rights reserved.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * SaveParticleParametersAction.cpp
+ *
+ *  Created on: Feb 27, 2016
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+// include headers that implement a archive in simple text format
+// and before MemDebug due to placement new
+#include <boost/archive/text_oarchive.hpp>
+#include <boost/archive/text_iarchive.hpp>
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "Actions/PotentialAction/SaveParticleParametersAction.hpp"
+
+#include <boost/filesystem.hpp>
+#include <fstream>
+
+#include "CodePatterns/Log.hpp"
+
+#include "Potentials/Exceptions.hpp"
+#include "Potentials/Particles/ParticleRegistry.hpp"
+#include "Potentials/RegistrySerializer.hpp"
+
+using namespace MoleCuilder;
+
+// and construct the stuff
+#include "SaveParticleParametersAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+
+ActionState::ptr PotentialSaveParticleParametersAction::performCall()
+{
+  // store the particles
+  if (!params.particle_file.get().string().empty()) {
+    // print fitted particles
+    std::stringstream particles;
+    try {
+      RegistrySerializer<Particle> serialize(
+          particles,
+          ParticleRegistry::getInstance(),
+          std::string("particle"));
+      serialize();
+    } catch (SerializerStreamException &e) {
+      STATUS("Error parsing stream, ended too early?");
+    }
+    LOG(1, "STATUS: Resulting parameters are " << std::endl << particles.str());
+    std::ofstream returnstream(params.particle_file.get().string().c_str());
+    if (returnstream.good()) {
+      returnstream << particles.str();
+    } else {
+      STATUS("Could not open stream to write particles!");
+      return Action::failure;
+    }
+  } else {
+    STATUS("No existing potential file given!");
+    return Action::failure;
+  }
+
+  return Action::success;
+}
+
+ActionState::ptr PotentialSaveParticleParametersAction::performUndo(ActionState::ptr _state) {
+  STATUS("Undo of PotentialSaveParticleParametersAction not implemented.");
+  return Action::failure;
+}
+
+ActionState::ptr PotentialSaveParticleParametersAction::performRedo(ActionState::ptr _state){
+  STATUS("Redo of PotentialSaveParticleParametersAction not implemented.");
+  return Action::failure;
+}
+
+bool PotentialSaveParticleParametersAction::canUndo() {
+  return false;
+}
+
+bool PotentialSaveParticleParametersAction::shouldUndo() {
+  return false;
+}
+/** =========== end of function ====================== */
Index: src/Actions/PotentialAction/SaveParticleParametersAction.def
===================================================================
--- src/Actions/PotentialAction/SaveParticleParametersAction.def	(revision 208263749128e6e2d6a33f16e925eb8d6076e7a6)
+++ src/Actions/PotentialAction/SaveParticleParametersAction.def	(revision 208263749128e6e2d6a33f16e925eb8d6076e7a6)
@@ -0,0 +1,37 @@
+/*
+ * SaveParticleParametersAction.def
+ *
+ *  Created on: Feb 27, 2016
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+#include "Parameters/Validators/Specific/FileSuffixValidator.hpp"
+#include "Parameters/Validators/Ops_Validator.hpp"
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (boost::filesystem::path)
+#define paramtokens ("save-particle-parameters")
+#define paramdescriptions ("TREMOLO particle file to write to")
+#define paramdefaults (NOPARAM_DEFAULT)
+#define paramreferences (particle_file)
+#define paramvalids \
+((FileSuffixValidator("particles") || FileSuffixValidator("potentials")))
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Potential
+#define MENUNAME "potential"
+#define MENUPOSITION 1
+#define ACTIONNAME SaveParticleParameters
+#define TOKEN "save-particle-parameters"
+
+
+// finally the information stored in the ActionTrait specialization
+#define DESCRIPTION "parses TREMOLO particle file"
+#undef SHORTFORM
Index: src/Actions/PotentialAction/SaveParticleParametersAction.hpp
===================================================================
--- src/Actions/PotentialAction/SaveParticleParametersAction.hpp	(revision 208263749128e6e2d6a33f16e925eb8d6076e7a6)
+++ src/Actions/PotentialAction/SaveParticleParametersAction.hpp	(revision 208263749128e6e2d6a33f16e925eb8d6076e7a6)
@@ -0,0 +1,22 @@
+/*
+ * SaveParticleParametersAction.hpp
+ *
+ *  Created on: Feb 27, 2016
+ *      Author: heber
+ */
+
+#ifndef SAVEPARTICLEPARAMETERSACTION_HPP_
+#define SAVEPARTICLEPARAMETERSACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include "Actions/Action.hpp"
+
+#include "SaveParticleParametersAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* SAVEPARTICLEPARAMETERSACTION_HPP_ */