Index: src/FunctionApproximation/Extractors.cpp
===================================================================
--- src/FunctionApproximation/Extractors.cpp	(revision 2ae400653042a5e875edc3698db0bccb2c978c93)
+++ src/FunctionApproximation/Extractors.cpp	(revision 22834071425b92bb49b92c2f643a1be0f4cde152)
@@ -62,4 +62,5 @@
     const Fragment::positions_t& positions,
     const Fragment::atomicnumbers_t& atomicnumbers,
+    const FragmentationEdges::edges_t &edges,
     const size_t globalid)
 {
@@ -88,4 +89,5 @@
           );
       arg.globalid = globalid;
+      arg.bonded = false;
       LOG(3, "DEBUG: Created argument " << arg << ".");
       result.push_back(arg);
Index: src/FunctionApproximation/Extractors.hpp
===================================================================
--- src/FunctionApproximation/Extractors.hpp	(revision 2ae400653042a5e875edc3698db0bccb2c978c93)
+++ src/FunctionApproximation/Extractors.hpp	(revision 22834071425b92bb49b92c2f643a1be0f4cde152)
@@ -16,4 +16,5 @@
 #include <boost/function.hpp>
 
+#include "Fragmentation/EdgesPerFragment.hpp"
 #include "Fragmentation/Summation/SetValues/Fragment.hpp"
 #include "FunctionApproximation/FunctionModel.hpp"
@@ -71,4 +72,5 @@
    * \param positions all nuclei positions
    * \param atomicNumber all nuclei atomic numbers
+   * \param edges edges of the fragment's bond graph
    * \param globalid index to associated in argument_t with
    * \return vector of argument_ , each with a distance
@@ -78,4 +80,5 @@
       const Fragment::positions_t& positions,
       const Fragment::atomicnumbers_t& atomicnumbers,
+      const FragmentationEdges::edges_t &edges,
       const size_t globalid);
 
@@ -85,4 +88,5 @@
    * \param positions all nuclei positions
    * \param atomicNumber all nuclei atomic numbers
+   * \param edges edges of the fragment's bond graph
    * \param index index refers to the index within the global set of configurations
    * \return vector of of argument_t containing all found distances
@@ -91,8 +95,9 @@
       const Fragment::positions_t& positions,
       const Fragment::atomicnumbers_t& atomicnumbers,
+      const FragmentationEdges::edges_t &edges,
       const size_t index
       ) {
     // get distance out of Fragment
-    return gatherAllSymmetricDistanceArguments(positions, atomicnumbers, index);
+    return gatherAllSymmetricDistanceArguments(positions, atomicnumbers, edges, index);
   }
 
Index: src/FunctionApproximation/TrainingData.cpp
===================================================================
--- src/FunctionApproximation/TrainingData.cpp	(revision 2ae400653042a5e875edc3698db0bccb2c978c93)
+++ src/FunctionApproximation/TrainingData.cpp	(revision 22834071425b92bb49b92c2f643a1be0f4cde152)
@@ -50,4 +50,5 @@
 #include "CodePatterns/toString.hpp"
 
+#include "Fragmentation/EdgesPerFragment.hpp"
 #include "Fragmentation/Summation/SetValues/Fragment.hpp"
 #include "FunctionApproximation/FunctionArgument.hpp"
@@ -59,7 +60,9 @@
     const HomologyGraph &graph = iter->first;
     const Fragment &fragment = iter->second.fragment;
+    const FragmentationEdges::edges_t &edges = iter->second.edges;
     FunctionModel::arguments_t all_args = Extractors::gatherAllSymmetricDistances(
         fragment.getPositions(),
         fragment.getAtomicNumbers(),
+        edges,
         DistanceVector.size()
         );
Index: src/FunctionApproximation/unittests/ExtractorsUnitTest.cpp
===================================================================
--- src/FunctionApproximation/unittests/ExtractorsUnitTest.cpp	(revision 2ae400653042a5e875edc3698db0bccb2c978c93)
+++ src/FunctionApproximation/unittests/ExtractorsUnitTest.cpp	(revision 22834071425b92bb49b92c2f643a1be0f4cde152)
@@ -89,6 +89,7 @@
 
   // create distances
+  FragmentationEdges::edges_t edges; // maybe left empty
   FunctionModel::arguments_t args =
-      Extractors::gatherAllSymmetricDistances(positions, atomicnumbers, 0);
+      Extractors::gatherAllSymmetricDistances(positions, atomicnumbers, edges, 0);
   CPPUNIT_ASSERT_EQUAL( (size_t)(5*4/2), args.size() );
 