Index: tests/regression/Parser/Pdb/post/CONECTs_emptyspace.pdb
===================================================================
--- tests/regression/Parser/Pdb/post/CONECTs_emptyspace.pdb	(revision 473237055cdf05b40bc70aa53d5b35d6960b4daf)
+++ tests/regression/Parser/Pdb/post/CONECTs_emptyspace.pdb	(revision 473237055cdf05b40bc70aa53d5b35d6960b4daf)
@@ -0,0 +1,6 @@
+REMARK created by molecuilder on Sat Apr 30 15:23:23 2011, time step 0
+ATOM      1 OE2 0GLU A1         43.510  13.802  28.945  1.00 15.92           O 0
+HETATM    2 MN  0MN  A1         45.531  14.928  28.983  1.00 18.19          MN 0
+CONECT    1    2                                                                
+CONECT    2    1                                                                
+END
Index: tests/regression/Parser/Pdb/pre/CONECTs_emptyspace.pdb
===================================================================
--- tests/regression/Parser/Pdb/pre/CONECTs_emptyspace.pdb	(revision 473237055cdf05b40bc70aa53d5b35d6960b4daf)
+++ tests/regression/Parser/Pdb/pre/CONECTs_emptyspace.pdb	(revision 473237055cdf05b40bc70aa53d5b35d6960b4daf)
@@ -0,0 +1,5 @@
+ATOM     56  OE2 GLU A   8      43.510  13.802  28.945  1.00 15.92           O  
+HETATM 7275 MN    MN A 238      45.531  14.928  28.983  1.00 18.19          MN  
+CONECT   56 7275                                                                
+CONECT 7275   56                                                                
+END
Index: tests/regression/Parser/Pdb/testsuite-parser-pdb-CONECTs_empty_space.at
===================================================================
--- tests/regression/Parser/Pdb/testsuite-parser-pdb-CONECTs_empty_space.at	(revision 473237055cdf05b40bc70aa53d5b35d6960b4daf)
+++ tests/regression/Parser/Pdb/testsuite-parser-pdb-CONECTs_empty_space.at	(revision 473237055cdf05b40bc70aa53d5b35d6960b4daf)
@@ -0,0 +1,10 @@
+### parsing pdb
+
+AT_SETUP([Parser - empty space in CONECTs of pdb])
+AT_KEYWORDS([parser,load,pdb,symbol,element])
+
+AT_CHECK([../../molecuilder -v 2 -i CONECTs_emptyspace.pdb -o pdb -l ${abs_top_srcdir}/tests/regression/Parser/Pdb/pre/CONECTs_emptyspace.pdb], 0, [stdout], [ignore])
+AT_CHECK([fgrep "gets 1 more neighbours" stdout], 0, [ignore], [ignore])
+AT_CHECK([file=CONECTs_emptyspace.pdb; diff -I '.*created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Parser/Pdb/post/CONECTs_emptyspace.pdb], 0, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/regression/Parser/Pdb/testsuite-parser-pdb-with-conects.at
===================================================================
--- tests/regression/Parser/Pdb/testsuite-parser-pdb-with-conects.at	(revision 8990879f0d70e37254ee9c7844475862be401b8a)
+++ tests/regression/Parser/Pdb/testsuite-parser-pdb-with-conects.at	(revision 473237055cdf05b40bc70aa53d5b35d6960b4daf)
@@ -5,5 +5,5 @@
 
 AT_CHECK([../../molecuilder -i test_conect.pdb -o pdb -l ${abs_top_srcdir}/tests/regression/Parser/Pdb/pre/test_conect.pdb], 0, [ignore], [ignore])
-AT_CHECK([file=test_conect.pdb; diff -I '.*created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Parser/Pdb/post/test_conect.pdb], 0, [ignore], [ignore])
+AT_CHECK([file=test_conect.pdb; diff -w -I '.*created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Parser/Pdb/post/test_conect.pdb], 0, [ignore], [ignore])
 
 AT_CLEANUP
@@ -15,5 +15,5 @@
 
 AT_CHECK([../../molecuilder -i test_conect.pdb -o pdb -l ${abs_top_srcdir}/tests/regression/Parser/Pdb/pre/test_conect.pdb --undo], 0, [ignore], [ignore])
-AT_CHECK([file=test_conect.pdb; diff -I '.*created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Parser/Pdb/post/empty.pdb], 0, [ignore], [ignore])
+AT_CHECK([file=test_conect.pdb; diff -w -I '.*created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Parser/Pdb/post/test_conect.pdb], 0, [ignore], [ignore])
 
 AT_CLEANUP
@@ -25,5 +25,5 @@
 
 AT_CHECK([../../molecuilder -i test_conect.pdb -o pdb -l ${abs_top_srcdir}/tests/regression/Parser/Pdb/pre/test_conect.pdb --undo --redo], 0, [ignore], [ignore])
-AT_CHECK([file=test_conect.pdb; diff -I '.*created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Parser/Pdb/post/test_conect.pdb], 0, [ignore], [ignore])
+AT_CHECK([file=test_conect.pdb; diff -w -I '.*created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Parser/Pdb/post/test_conect.pdb], 0, [ignore], [ignore])
 
 AT_CLEANUP